#include "sx127x_driver.h"

esp_err_t sx127x_read_register(sx127x_t *handle, uint8_t reg, uint8_t *value);
esp_err_t sx127x_write_register(sx127x_t *handle, uint8_t reg, uint8_t value);
esp_err_t sx127x_single_transfer(sx127x_t *handle, uint8_t addr,
                                 uint8_t to_slave, uint8_t *from_slave);

esp_err_t sx127x_sleep(sx127x_t *handle);

esp_err_t sx127x_standby(sx127x_t *handle);

esp_err_t sx127x_set_frequency(sx127x_t *handle, uint64_t frequency);

esp_err_t sx127x_set_tx_power(sx127x_t *handle, uint8_t tx_power,
                              sx127x_pa_boost_t pa_boost);

esp_err_t sx127x_set_spreading_factor(sx127x_t *handle,
                                      uint8_t   spreading_factor);

esp_err_t sx127x_set_signal_bandwidth(sx127x_t *handle,
                                      uint64_t  signal_bandwidth);
uint8_t   sx127x_bw_to_reg(uint64_t bandwidth);
uint64_t  sx127x_reg_to_bw(uint8_t bandwidth_reg);

esp_err_t sx127x_set_sync_word(sx127x_t *handle, uint8_t sync_word);

esp_err_t sx127x_set_crc(sx127x_t *handle, sx127x_crc_t crc);

esp_err_t sx127x_write_fifo(sx127x_t *handle, const char *data, size_t data_len);
esp_err_t sx127x_read_fifo(sx127x_t *handle, char *data_out,
                           size_t *data_len_out);
